from setuptools import setup

with open("README.md", "r", encoding="utf-8") as fh:
    long_description = fh.read()

setup(
    name='Ocrversion2',
    version='0.2.0',
    packages=['Ocrversion1'],
    install_requires=[
        'annotated-types==0.6.0',
        'anyio==3.7.1',
        'certifi==2022.12.7',
        'cffi==1.16.0',
        'charset-normalizer==2.1.1',
        'click==8.1.7',
        'colorama==0.4.6',
        'contourpy==1.2.0',
        'cryptography==41.0.7',
        'cycler==0.12.1',
        'easyocr==1.7.1',
        'fastapi==0.104.1',
        'filelock==3.9.0',
        'fonttools==4.46.0',
        'fsspec==2023.4.0',
        'h11==0.14.0',
        'idna==3.4',
        'imageio==2.33.0',
        'iopath==0.1.10',
        'Jinja2==3.1.2',
        'kiwisolver==1.4.5',
        'lazy_loader==0.3',
        'llvmlite==0.41.1',
        'MarkupSafe==2.1.3',
        'matplotlib==3.8.2',  # Corrected version number
        'mplcursors==0.5.2',
        'mpmath==1.3.0',
        'networkx==3.0',
        'ninja==1.11.1.1',
        'numba==0.58.1',
        'numpy==1.24.1',
        'opencv-python==4.8.1.78',
        'opencv-python-headless==4.8.1.78',
        'packaging==23.2',
        'pandas==2.1.4',
        'pdf2image==1.16.3',
        'pdfminer.six==20221105',
        'pdfplumber==0.10.3',
        'Pillow==10.1.0',
        'portalocker==2.8.2',
        'pyclipper==1.3.0.post5',
        'pycparser==2.21',
        'pydantic==2.5.2',
        'pydantic_core==2.14.5',
        'PyMuPDF==1.23.7',
        'PyMuPDFb==1.23.7',
        'pyparsing==3.1.1',
        'pypdfium2==4.24.0',
        'python-bidi==0.4.2',
        'python-dateutil==2.8.2',
        'python-multipart==0.0.6',
        'pytz==2023.3.post1',
        'pywin32==306',
        'PyYAML==6.0.1',
        'requests==2.28.1',
        'scikit-image==0.22.0',
        'scipy==1.11.4',
        'shapely==2.0.2',
        'six==1.16.0',
        'sniffio==1.3.0',
        'starlette==0.27.0',
        'sympy==1.12',
        'tifffile==2023.9.26',
        'torch==2.1.1',
        'torchaudio==2.1.1',
        'torchvision==0.16.1',
        'tqdm==4.66.1',
        'typing_extensions==4.8.0',
        'tzdata==2023.3',
        'urllib3==1.26.13',
        'uvicorn==0.24.0.post1'
    ],
    long_description=long_description,
    long_description_content_type="text/markdown",
)
